local T, C, L, _ = unpack(select(2, ...))
if C.skins.meetinghorn ~= true then return end

----------------------------------------------------------------------------------------
--	MeetingHorn skin
----------------------------------------------------------------------------------------
if IsAddOnLoaded("MeetingHorn") then
	local MeetingHorn = LibStub("AceAddon-3.0"):GetAddon("MeetingHorn", true)
	if not MeetingHorn then return end

	local MainPanel = _G.MeetingHornMainPanel or MeetingHorn.MainPanel
	local ListView = MeetingHorn:GetClass("UI.ListView")

	local function SkinDropDownBox(frame)
		local frameName = frame.GetName and frame:GetName()
		local button = frame.Button or frame.MenuButton or frameName and (_G[frameName.."Button"] or _G[frameName.."_Button"])

		button:ClearAllPoints()
		button:SetPoint("RIGHT", frame, "RIGHT", 0, 2)
		button.SetPoint = T.dummy
		T.SkinNextPrevButton(button, nil, "Down")

		frame:StripTextures()
		frame:CreateBackdrop("Overlay")
		frame:SetFrameLevel(frame:GetFrameLevel() + 2)
		frame.backdrop:SetPoint("TOPLEFT", 0, 1)
		frame.backdrop:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 2, -2)
	end

	for k, tab in ipairs(MainPanel.Tabs) do
		if k == 1 then
			local relF, parent, relT, x, y = tab:GetPoint()
			tab:SetPoint(relF, parent, relT, x, y - 1)
		end

		tab.Text:SetPoint("TOP", tab, 0, -3)
		tab:StripTextures()		
		local a, b = tab:GetSize()
		tab:SetSize(a, b - 10)
		T.SkinTab(tab)
	end

	hooksecurefunc(ListView, "GetButton", function(self, index)
		local button = self._buttons[index]
		if button and not button.styled then
			if button.Signup then
				button.Signup:SkinButton()
				button.Signup:SetSize(60, 20)
			end
			button.styled = true
		end
	end)

	local StripAllTextures = {
		MeetingHornDataBroker,
		MainPanel,
		MainPanel.Loading,
		MainPanel.Browser,
		MainPanel.Browser.QRTooltip,
		MainPanel.Browser.ProgressBar,
		MainPanel.Browser.Activity,
		MainPanel.Browser.ActivityList,
		MainPanel.Browser.Empty,
		MainPanel.Browser.Mode,
		MainPanel.Browser.Header1,
		MainPanel.Browser.Header2,
		MainPanel.Browser.Header3,
		MainPanel.Browser.Header4,
		MainPanel.Browser.Header5,
		MainPanel.Browser.Header6,
		MainPanel.Browser.Header7,
		MainPanel.Browser.Header8,
		MainPanel.Manage,
		MainPanel.Manage.Creator,
		MainPanel.Manage.Creator.Activity,
		MainPanel.Manage.Creator.Mode,
		MainPanel.Manage.Creator.Comment,
		MainPanel.Manage.Creator.Comment.ScrollFrame,
		MainPanel.Manage.Chat,
		MainPanel.Manage.Chat.ChatFrame,
		MainPanel.Manage.Chat.ChatBg,
		MainPanel.GoodLeader,
		MainPanel.GoodLeader.First.Header,
		MainPanel.GoodLeader.First.Footer,
		MainPanel.GoodLeader.First.Inset,
		MainPanel.GoodLeader.Result,
		MainPanel.GoodLeader.Result.Raids,
		MainPanel.GoodLeader.Result.Score,
		MainPanel.GoodLeader.Result.Info,
		MainPanel.MissionGuidance,
		MainPanel.Encounter,
		MainPanel.Encounter.Instance,
		MainPanel.Encounter.BossList,
		MainPanel.Recent,
		MainPanel.Recent.Instance,
		MainPanel.Recent.Left,
		MainPanel.Recent.Members,
		MainPanel.Recent.Right,
		MainPanel.Recent.QRCode,
		MainPanel.Recent.QRCode.CodeFrame,
		MainPanel.Challenge,
		MainPanel.Challenge.Left,
		MainPanel.Challenge.Body,
		MainPanel.Challenge.Summary,
		MainPanel.Help,
		MainPanel.Options,
		MainPanel.Options.Options,
		MainPanel.Options.Filters,
		MainPanel.Options.Filters.FilterInputBox,
	}

	local SetTemplate1 = {
		MainPanel,
		MainPanel.Manage,		
		MainPanel.Recent,	
		MainPanel.Options,			
		MainPanel.Challenge,
		MainPanel.Options.Filters.FilterInputBox,
	}

	local SetTemplate2 = {
		MainPanel.Loading,
		MainPanel.Browser.QRTooltip,
		MainPanel.Browser.Activity,
		MainPanel.Browser.Mode,
		MainPanel.Browser.ActivityList,
		MainPanel.Browser.Empty,
		MainPanel.Browser.Header1,
		MainPanel.Browser.Header2,
		MainPanel.Browser.Header3,
		MainPanel.Browser.Header4,
		MainPanel.Browser.Header5,
		MainPanel.Browser.Header6,
		MainPanel.Browser.Header7,
		MainPanel.Browser.Header8,
		MainPanel.Manage.Creator,
		MainPanel.Manage.Creator.Activity,
		MainPanel.Manage.Creator.Mode,
		MainPanel.Manage.Creator.Comment,
		MainPanel.Manage.Creator.Comment.ScrollFrame,
		MainPanel.Manage.Chat,
		MainPanel.Manage.Chat.ChatFrame,
		MainPanel.Manage.Chat.ChatBg,
		MainPanel.GoodLeader,
		MainPanel.GoodLeader.First.Header,
		MainPanel.GoodLeader.First.Footer,
		MainPanel.GoodLeader.First.Inset,
		MainPanel.GoodLeader.Result,
		MainPanel.GoodLeader.Result.Raids,
		MainPanel.GoodLeader.Result.Score,
		MainPanel.GoodLeader.Result.Info,
		MainPanel.MissionGuidance,
		MainPanel.Encounter,		
		MainPanel.Encounter.BossList,
		MainPanel.Encounter.Instance,		
		MainPanel.Recent.Instance,
		MainPanel.Recent.Right,
		MainPanel.Recent.Left,
		MainPanel.Recent.Members,
		MainPanel.Recent.QRCode,
		MainPanel.Recent.QRCode.CodeFrame,
		MainPanel.Challenge.Left,		
		MainPanel.Challenge.Body,
		MainPanel.Challenge.Summary,
		MainPanel.Options.Options,
		MainPanel.Options.Filters.FilterList,
		MainPanel.Help,
	}

	local Buttons = {
		MainPanel.Browser.Reset,
		MainPanel.Browser.Refresh,
		MainPanel.Browser.ApplyLeaderBtn,
		MainPanel.Browser.RechargeBtn,
		MainPanel.Manage.Creator.CreateButton,
		MainPanel.Manage.Creator.CloseButton,
		MainPanel.Manage.Creator.RecruitButton,
		MainPanel.GoodLeader.First.Header.ApplyLeaderBtn,
		--MainPanel.GoodLeader.First.Header.Search,
		MainPanel.Recent.Invite,
		MainPanel.Options.Filters.Add,
		MainPanel.Options.Filters.Import,
		MainPanel.Options.Filters.Export,
		MainPanel.FeedBack.AcceptButton,
		MainPanel.FeedBack.CancelButton,
		MainPanel.Challenge.Body.Reward.Exchange,
		MainPanel.Challenge.Body.Reward.View,
		MainPanel.Challenge.Body.UpdateButton,
		MainPanel.Challenge.Body.WebButton,
	}

	local DropDownBox = {
		MainPanel.Browser.Activity,
		MainPanel.Browser.Mode,
		MainPanel.Browser.Quick,
		MainPanel.Manage.Creator.Activity,
		MainPanel.Manage.Creator.Mode,
		MainPanel.Recent.Instance,
		MainPanel.Encounter.Instance,
		MainPanel.Challenge.Left.Groups,
	}

	local Editboxs = {
		MainPanel.Browser.Input,
		MainPanel.Options.Filters.FilterInputBox.Input,
	}

	local ScrollBars = {
		MainPanel.Browser.ActivityList.scrollBar,
		MainPanel.Manage.Chat.ChatFrame.scrollBar,
		MainPanel.Manage.Applicant.ApplicantList.scrollBar,
		MainPanel.Manage.Creator.Comment.ScrollFrame.ScrollBar,
		MainPanel.Encounter.BossList.scrollBar,
		MainPanel.FeedBack.EditBox.ScrollFrame.ScrollBar,
		MainPanel.ScrollBar,
		MainPanel.Recent.Members.scrollBar,
		MainPanel.Options.Filters.FilterList.scrollBar,
	}

	local Buttons1 = {MainPanel.Options.Filters.FilterInputBox:GetChildren()}
	for _, object in pairs(Buttons1) do
		if object:IsObjectType("Button") then
			object:SkinButton()
		end
	end

	local Buttons2 = {MainPanel:GetChildren()}
	for _, v in pairs(Buttons2) do
		if v.AcceptButton then
			v.AcceptButton:SkinButton()
		end
		if v.CancelButton then
			v.CancelButton:SkinButton()
		end
	end

	for _, object in pairs(StripAllTextures) do
		object:StripTextures()
	end

	for k, object in pairs(SetTemplate1) do
		object:SetTemplate("Transparent")
	end

	for k, object in pairs(SetTemplate2) do
		object:SetTemplate("Overlay")
	end

	for _, object in pairs(Buttons) do
		object:SkinButton()
	end

	for _, object in pairs(DropDownBox) do
		SkinDropDownBox(object, 100)
	end

	for _, object in pairs(Editboxs) do
		T.SkinEditBox(object, 200, 18)
	end	

	for _, object in pairs(ScrollBars) do
		T.SkinScrollBar(object)
	end	

	MainPanel.FeedBackButton:Hide()
	MainPanel.Browser.ProgressBar:CreateBackdrop("Default")
	MainPanel.Browser.ProgressBar:SetStatusBarTexture(C.media.texture)
	T.SkinCloseButton(MainPanel.CloseButton)
end